unit IniFiles;

// tiny IniFiles unit (c) 2006 by Paul TOTH

// a way to keep SIPInside near 500Ko

interface

uses
 Windows, Classes, SysUtils;

type
  TIniFile=class
  private
   fFileName:string;
   pFileName:pchar;
  public
   constructor Create(const AFileName:string);
   function ReadString(const ASection, AKey, ADefault:string):string;
   procedure WriteString(const ASection,AKey,AValue:string);
   procedure ReadSection(const ASection:string; Strings:TStrings);
   procedure DeleteKey(const ASection, AKey: string);
  end;

implementation

constructor TIniFile.Create(const AFileName:string);
begin
 fFileName:=AFileName;
 pFileName:=@fFileName[1];
end;

function TIniFile.ReadString(const ASection,AKey,ADefault:string):string;
var
 i:integer;
begin
 SetLength(Result,512);
 i:=GetPrivateProfileString(pchar(ASection),PChar(AKey),PChar(ADefault),@Result[1],512,pFileName);
 SetLength(Result,i);
end;

procedure TIniFile.WriteString(const ASection,AKey,AValue:string);
begin
 WritePrivateProfileString(pchar(ASection),PChar(AKey),PChar(AValue),pFileName);
end;

procedure TIniFile.ReadSection(const ASection:string; Strings:TStrings);
var
 s:string;
 p:pchar;
begin
 Strings.BeginUpdate;
 try
  Strings.Clear;
  SetLength(s,16384);
  if GetPrivateProfileString(pchar(ASection),nil,nil,@s[1],16384,pFileName)=0 then exit;
  p:=@s[1];
  while p^<>#0 do begin
   Strings.Add(P);
   inc(p, StrLen(p) + 1);
  end;
 finally
  Strings.EndUpdate;
 end;
end;

procedure TIniFile.DeleteKey(const ASection, AKey: string);
begin
  WritePrivateProfileString(PChar(ASection), PChar(AKey), nil, pFileName);
end;

end.
